>From f8cf8139f993010948c16c0499a045efd6a65ff6 Mon Sep 17 00:00:00 2001
From: Abhishek Koneru <akoneru@redhat.com>
Date: Mon, 22 Jul 2013 21:16:59 -0400
Subject: [PATCH] Adding pylint scan to the build.

Adding the scripts and the pylintrc file to the build process.
The script is called before packaging the classes in the compose
scripts.

Ticket #316
---
 dogtag.pylintrc                   |  259 +++++++++++++++++++++++++++++++++++++
 pylint-build-scan.sh              |   58 +++++++++
 scripts/compose_pki_core_packages |   16 +++
 3 files changed, 333 insertions(+)
 create mode 100644 dogtag.pylintrc
 create mode 100755 pylint-build-scan.sh

diff --git a/dogtag.pylintrc b/dogtag.pylintrc
new file mode 100644
index 0000000000000000000000000000000000000000..b5966318b1b3fd9c95767b51b5fe67a6bc576728
--- /dev/null
+++ b/dogtag.pylintrc
@@ -0,0 +1,259 @@
+[MASTER]
+
+# Specify a configuration file.
+#rcfile=
+
+# Python code to execute, usually for sys.path manipulation such as
+# pygtk.require().
+#init-hook=
+
+# Profiled execution.
+profile=no
+
+# Add files or directories to the blacklist. They should be base names, not
+# paths.
+ignore=CVS
+
+# Pickle collected data for later comparisons.
+persistent=yes
+
+# List of plugins (as comma separated values of python modules names) to load,
+# usually to register additional checkers.
+load-plugins=
+
+
+[MESSAGES CONTROL]
+
+# Enable the message, report, category or checker with the given id(s). You can
+# either give multiple identifier separated by comma (,) or put this option
+# multiple time.
+#enable=
+
+# Disable the message, report, category or checker with the given id(s). You
+# can either give multiple identifier separated by comma (,) or put this option
+# multiple time (only on the command line, not in the configuration file where
+# it should appear only once).
+disable=C,R,I,W0511,W0105
+
+
+[REPORTS]
+
+# Set the output format. Available formats are text, parseable, colorized, msvs
+# (visual studio) and html. You can also give a reporter class, eg
+# mypackage.mymodule.MyReporterClass.
+output-format=text
+
+# Include message's id in output
+include-ids=yes
+
+# Include symbolic ids of messages in output
+symbols=no
+
+# Put messages in a separate file for each module / package specified on the
+# command line instead of printing them on stdout. Reports (if any) will be
+# written in a file name "pylint_global.[txt|html]".
+files-output=no
+
+# Tells whether to display a full report or only the messages
+reports=yes
+
+# Python expression which should return a note less than 10 (10 is the highest
+# note). You have access to the variables errors warning, statement which
+# respectively contain the number of errors / warnings messages and the total
+# number of statements analyzed. This is used by the global evaluation report
+# (RP0004).
+evaluation=10.0 - ((float(5 * error + warning + refactor + convention) / statement) * 10)
+
+# Add a comment according to your evaluation note. This is used by the global
+# evaluation report (RP0004).
+comment=no
+
+
+[FORMAT]
+
+# Maximum number of characters on a single line.
+max-line-length=100
+
+# Maximum number of lines in a module
+max-module-lines=1000
+
+# String used as indentation unit. This is usually " " (4 spaces) or "\t" (1
+# tab).
+indent-string='    '
+
+
+[MISCELLANEOUS]
+
+# List of note tags to take in consideration, separated by a comma.
+notes=FIXME,XXX,TODO
+
+
+[VARIABLES]
+
+# Tells whether we should check for unused import in __init__ files.
+init-import=no
+
+# A regular expression matching the beginning of the name of dummy variables
+# (i.e. not used).
+dummy-variables-rgx=_|dummy
+
+# List of additional names supposed to be defined in builtins. Remember that
+# you should avoid to define new builtins when possible.
+additional-builtins=
+
+
+[SIMILARITIES]
+
+# Minimum lines number of a similarity.
+min-similarity-lines=4
+
+# Ignore comments when computing similarities.
+ignore-comments=yes
+
+# Ignore docstrings when computing similarities.
+ignore-docstrings=yes
+
+# Ignore imports when computing similarities.
+ignore-imports=no
+
+
+[TYPECHECK]
+
+# Tells whether missing members accessed in mixin class should be ignored. A
+# mixin class is detected if its name ends with "mixin" (case insensitive).
+ignore-mixin-members=yes
+
+# List of classes names for which member attributes should not be checked
+# (useful for classes with attributes dynamically set).
+ignored-classes=SQLObject, json.encoder.JSONEncoder
+
+# When zope mode is activated, add a predefined set of Zope acquired attributes
+# to generated-members.
+zope=no
+
+# List of members which are set dynamically and missed by pylint inference
+# system, and so shouldn't trigger E0201 when accessed. Python regular
+# expressions are accepted.
+generated-members=REQUEST,acl_users,aq_parent
+
+
+[BASIC]
+
+# Required attributes for module, separated by a comma
+required-attributes=
+
+# List of builtins function names that should not be used, separated by a comma
+bad-functions=map,filter,apply,input
+
+# Regular expression which should only match correct module names
+module-rgx=(([a-z_][a-z0-9_]*)|([A-Z][a-zA-Z0-9]+))$
+
+# Regular expression which should only match correct module level names
+const-rgx=(([A-Z_][A-Z0-9_]*)|(__.*__))$
+
+# Regular expression which should only match correct class names
+class-rgx=[A-Z_][a-zA-Z0-9]+$
+
+# Regular expression which should only match correct function names
+function-rgx=[a-z_][a-z0-9_]{2,30}$
+
+# Regular expression which should only match correct method names
+method-rgx=[a-z_][a-z0-9_]{2,30}$
+
+# Regular expression which should only match correct instance attribute names
+attr-rgx=[a-z_][a-z0-9_]{2,30}$
+
+# Regular expression which should only match correct argument names
+argument-rgx=[a-z_][a-z0-9_]{2,30}$
+
+# Regular expression which should only match correct variable names
+variable-rgx=[a-z_][a-z0-9_]{2,30}$
+
+# Regular expression which should only match correct list comprehension /
+# generator expression variable names
+inlinevar-rgx=[A-Za-z_][A-Za-z0-9_]*$
+
+# Good variable names which should always be accepted, separated by a comma
+good-names=i,j,k,ex,Run,rv,_
+
+# Bad variable names which should always be refused, separated by a comma
+bad-names=foo,bar,baz,toto,tutu,tata
+
+# Regular expression which should only match functions or classes name which do
+# not require a docstring
+no-docstring-rgx=__.*__
+
+
+[DESIGN]
+
+# Maximum number of arguments for function / method
+max-args=5
+
+# Argument names that match this expression will be ignored. Default to name
+# with leading underscore
+ignored-argument-names=_.*
+
+# Maximum number of locals for function / method body
+max-locals=15
+
+# Maximum number of return / yield for function / method body
+max-returns=6
+
+# Maximum number of branch for function / method body
+max-branchs=12
+
+# Maximum number of statements in function / method body
+max-statements=50
+
+# Maximum number of parents for a class (see R0901).
+max-parents=7
+
+# Maximum number of attributes for a class (see R0902).
+max-attributes=7
+
+# Minimum number of public methods for a class (see R0903).
+min-public-methods=2
+
+# Maximum number of public methods for a class (see R0904).
+max-public-methods=20
+
+
+[CLASSES]
+
+# List of interface methods to ignore, separated by a comma. This is used for
+# instance to not check methods defines in Zope's Interface base class.
+ignore-iface-methods=isImplementedBy,deferred,extends,names,namesAndDescriptions,queryDescriptionFor,getBases,getDescriptionFor,getDoc,getName,getTaggedValue,getTaggedValueTags,isEqualOrExtendedBy,setTaggedValue,isImplementedByInstancesOf,adaptWith,is_implemented_by
+
+# List of method names used to declare (i.e. assign) instance attributes.
+defining-attr-methods=__init__,__new__,setUp
+
+# List of valid names for the first argument in a class method.
+valid-classmethod-first-arg=cls
+
+# List of valid names for the first argument in a metaclass class method.
+valid-metaclass-classmethod-first-arg=mcs
+
+
+[IMPORTS]
+
+# Deprecated modules which should not be used, separated by a comma
+deprecated-modules=regsub,TERMIOS,Bastion,rexec
+
+# Create a graph of every (i.e. internal and external) dependencies in the
+# given file (report RP0402 must not be disabled)
+import-graph=
+
+# Create a graph of external dependencies in the given file (report RP0402 must
+# not be disabled)
+ext-import-graph=
+
+# Create a graph of internal dependencies in the given file (report RP0402 must
+# not be disabled)
+int-import-graph=
+
+
+[EXCEPTIONS]
+
+# Exceptions that will emit a warning when being caught. Defaults to
+# "Exception"
+#overgeneral-exceptions=Exception
diff --git a/pylint-build-scan.sh b/pylint-build-scan.sh
new file mode 100755
index 0000000000000000000000000000000000000000..879d4215a43607027860f7cb79cffd118dd36a82
--- /dev/null
+++ b/pylint-build-scan.sh
@@ -0,0 +1,58 @@
+#!/bin/sh -x
+
+if [ -z "$1" ]
+then
+  echo "PKI codebase home not specified. Could not scan the python scripts. Returning 0 - for SUCCESS"
+  echo 0
+  exit 0
+fi
+
+rv=`rpm -qa pylint`
+
+if [ -z $rv ]
+then
+  echo "Pylint not installed. Could not perforn scan. Returning 0 - for success"
+  echo 0
+  exit 0
+fi
+
+HOME_DIR=$1
+
+PYLINT_TEMP_DIR="$HOME_DIR/pylintscan/pki"
+
+PYLINT_RC_FILE_PATH="$HOME_DIR/dogtag.pylintrc"
+
+cd $HOME_DIR
+mkdir -p $PYLINT_TEMP_DIR
+
+# Copy all the python code to their respective directories
+# Same as the deployed structure
+
+cp -r base/server/python/pki/server/ $PYLINT_TEMP_DIR
+
+cp -r base/common/python/pki/*.py $PYLINT_TEMP_DIR
+
+cp -r base/server/sbin $PYLINT_TEMP_DIR
+
+cp -r base/common/sbin/* $PYLINT_TEMP_DIR/sbin
+
+cd $PYLINT_TEMP_DIR/..
+
+rv=`pylint --rcfile=$PYLINT_RC_FILE_PATH pki/ pki/server/deployment/ pki/server/deployment/scriptlets/ pki/sbin/pkispawn pki/sbin/pkidestroy pki/sbin/pki-upgrade pki/sbin/pki-server-upgrade >> pylint-report`
+
+status=$?
+
+#Excerpt from pylint man page
+#OUTPUT STATUS CODE
+#       Pylint should leave with following status code:
+#           * 0 if everything went fine
+#           * 1 if a fatal message was issued
+#           * 2 if an error message was issued
+#           * 4 if a warning message was issued
+#           * 8 if a refactor message was issued
+#           * 16 if a convention message was issued
+#           * 32 on usage error
+#
+#       status 1 to 16 will be bit-ORed so you can know which different categories has been issued by analysing pylint output status code
+
+echo $status
diff --git a/scripts/compose_pki_core_packages b/scripts/compose_pki_core_packages
index 99d480c31a1b2c565055f24940c2b15355a79b31..bc918d43551f62a3c9a697b6be409da965e0e668 100755
--- a/scripts/compose_pki_core_packages
+++ b/scripts/compose_pki_core_packages
@@ -193,6 +193,22 @@ printf "#!/bin/bash\n\n"                 >  ${PKI_CORE_PACKAGE_SCRIPT}
 printf "${PKI_CORE_PACKAGE_COMMAND}\n\n" >> ${PKI_CORE_PACKAGE_SCRIPT}
 chmod 775 ${PKI_CORE_PACKAGE_SCRIPT}
 
+##
+## Run a pylint scan to check for warnings and errors in the python code
+##
+
+cd $PKI_DIR
+PYLINT_STATUS_CODE=`./pylint-build-scan.sh $PKI_PWD/$PKI_DIR`
+if [ $PYLINT_STATUS_CODE != 0 ]; then
+   echo
+   echo "###############################################################################"
+   echo "                   !!!! Errors reported by Pylint !!!!"
+   echo "###############################################################################"
+   echo -e "The complete report can be viewed at: \n    $PKI_PWD/$PKI_DIR/pylintscan/pylint-report.    "
+   echo -e "If the reported issues are false positives, please mark them ignored  \nin the configuration file '$PKI_PWD/$PKI_DIR/dogtag.pylintrc' \nand build again."
+   echo "###############################################################################"
+   exit 1
+fi
 
 ##
 ## Automatically invoke RPM/SRPM creation
-- 
1.7.10.2